package gs.db;

import gs.db.query;
import java.util.Hashtable;
import java.sql.ResultSet;

public abstract class database {

  protected Hashtable fields;

  public database() 
  {
    fields = new Hashtable();
  }

  abstract public String getTableName();
  abstract public String getFieldNames();
  abstract public String getFieldValues();
  abstract public String getSetValues();

  public String insertSQL() 
  {
    return "INSERT INTO "+ getTableName() + " ("+ getFieldNames() +") "+
       "VALUES ("+ getFieldValues() +")";
  }
  
  public String updateSQL(String whereClause) 
  {
    return "UPDATE "+ getTableName()
      + " SET " + getSetValues()
      + " WHERE " + whereClause;
  }

  public String deleteSQL(String whereClause) 
  {
    return "DELETE FROM "+ getTableName() 
      +" WHERE "+ whereClause;
  }

  public Hashtable getFields()
  {
    return fields;
  }

  public ResultSet records(String proj, 
			   String where, 
			   String order) 
       throws Exception 
  {
    if(proj.equals("")) proj = "*";
    if(!where.equals("")) where = " WHERE " + where;
    if(!order.equals("")) order = " ORDER BY " + order;
    
    String queryString = "SELECT "+proj
      +" FROM "+ getTableName() + where + order;

    ResultSet rs = null;
    try {
      rs = query.queryData( queryString );
    } catch(Exception e) {
      throw e;
    }
    return rs;
  }
}
