package gs.admin;

import java.util.Hashtable;

import java.io.IOException;

import javax.servlet.Servlet;
import javax.servlet.ServletException;
import javax.servlet.ServletOutputStream;
import javax.servlet.ServletContext;
import javax.servlet.ServletConfig;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpUtils;


import gs.db.update;
import gs.db.dbUser;
import gs.db.groupusers;

import java.sql.ResultSet;

import gs.html.Html;
import gs.html.Parser;
import gs.html.RecordParser;


/**
 */
public class gUsers extends HttpServlet {

    /**
     * Service the request.
     *
     * @exception  ServletException if there is any sort of Exception
     *
     */

  public static int MIN_LOGIN_NAME_LENGTH = 3;
  public static int MIN_PASSWORD_LENGTH = 5;
  public gSystem  sys=new gSystem();

  public void doPost  (
		       HttpServletRequest req,
		       HttpServletResponse response
			) throws IOException, ServletException
  {
    processInOut( req,response);
  }

  public void doGet(HttpServletRequest req, HttpServletResponse response)
       throws IOException, ServletException
  {
    processInOut( req,response);
  }


  public void processInOut (
			    HttpServletRequest req,
			    HttpServletResponse response
			     ) throws IOException, ServletException
  {

    response.setStatus(HttpServletResponse.SC_OK); 
    response.setContentType("text/html");
    
    ServletOutputStream out = response.getOutputStream();

    String templateFile = req.getPathTranslated();
    System.out.println( templateFile);
    String unum = req.getParameter("unum"); 
    String command = req.getParameter("comm"); 
    //    out.println( Html.header("User Records") );



    if(command.equals("list"))
      listUsers(out, req.getPathTranslated(), false);
    else if(command.equals("LISTALL"))
      listUsers(out, req.getPathTranslated(), true);
    else if(command.equals("FRAME"))
      decideFrame(out,req.getPathTranslated(),
		  req.getParameter("framecomm"),
		  req.getParameter("file"),unum,req.getParameter("gslogin"));
    else if(command.equals("SHOW"))
      browseUser(out, req.getPathTranslated(), req.getParameter("gslogin"));
    else if(command.equals("NEW"))
      newUserFrame(out, req.getPathTranslated());
    else if(command.equals("NEWRECORD"))
      newUserRecord(out, req.getPathTranslated());
    else if(command.equals("SKIP"))
      skip(out,req.getPathTranslated(), unum);
    else if(command.equals("CANCEL"))
      out.println("<script language=JavaScript> history.go(-2);</script>");
    else if(command.equals("EDIT"))
      editUserFrame(out, req.getPathTranslated(),(String)(req.getParameter("gslogin")));
    else if(command.equals("EDITRECORD"))
      editUserRecord(out, req.getPathTranslated(),(String)(req.getParameter("gslogin")));

    else if(command.equals("DELETE"))
      deleteUser(out, req.getPathTranslated(), unum,
		 (String)(req.getParameter("gslogin")), (String)(req.getParameter("answer")));

    else if(command.equals("UPDATE")) {
      try { 
	updateUser(out,readUserFields(req), req.getPathTranslated());
      } catch (Exception e) {
	System.out.println("<h2>ERROR: "+templateFile);
	sys.error(out,e.getMessage());
      }
    }
    else if(command.equals("ADD")) {
      try { 
	addUser(out,readUserFields(req), req.getPathTranslated());
      } catch (Exception e) {
	out.println("<h2>ERROR: "+e.getMessage());
	out.println("<HR>");
      }
    }



    //    out.println( Html.footer() );
    out.close();
  
  }


    ////----------------------------------

  public dbUser readUserFields(HttpServletRequest req) throws Exception {

      dbUser u=new dbUser();

      u.gslogin   = req.getParameter("gslogin"); 
      System.out.println("gslogin----------->"+u.gslogin+req.getParameter("gslogin"));
      u.firstname = req.getParameter("firstname"); 
      u.midname   = req.getParameter("midname");
      u.lastname  = req.getParameter("lastname"); 
      u.gspwd     = req.getParameter("gspwd"); 
      String confirm   = req.getParameter("confirmgspwd"); 
      
      if(u.gslogin.equals("") || u.firstname.equals("") || u.lastname.equals("") 
	 || u.gspwd.equals("") || confirm.equals("")) 
       throw new Exception("Please enter in all the fields in red!");
      else if (u.gslogin.length() < gUsers.MIN_LOGIN_NAME_LENGTH) 
	throw new Exception("Users' login names must be at least 3 digits long!");
      else if (!u.gspwd.equals(confirm)) 
	throw new Exception("Passwords do not match!");
    else if (u.gspwd.length() < gUsers.MIN_PASSWORD_LENGTH) 
      throw new Exception("Password must be at least 5 characters long!");
      else {
	u.idnum = req.getParameter("idnum");
	u.privilige = req.getParameter("privilige");
	System.out.println("PRIVILIGE   "+u.privilige );
	u.ACL       = req.getParameter("access");
	u.email     = req.getParameter("email"); 
	u.dept      = req.getParameter("dept"); 
	u.url       = req.getParameter("url");  
	u.picurl    = req.getParameter("picurl");  
	u.phone     = req.getParameter("phone"); 
	u.room      = req.getParameter("room");  
	u.systemslogin   = req.getParameter("systemslogin");
	u.comments = req.getParameter("comments");
        u.reserved  = req.getParameter("reserved");
      }
      
      return u;

  }
  
  String   findRestrictedList(String acl){
    return "<OPTION>me";
  }


  //////////////////////////////////////////////////////////////////////////  
  void listUsers(ServletOutputStream out, 
		 String templateFile, 
		 boolean allFields)
       throws IOException
  {

    try {
      Hashtable ht = new Hashtable();
      ht.put("host", "http://osprey7.npac.syr.edu:5757");
      ht.put("servlet", "GS");

      StringBuffer output = new StringBuffer();
      String fieldNames = "gslogin,firstname,midname,lastname,url";

      String queryProjection = fieldNames;
      dbUser u = new dbUser();

      if(allFields) 
	{
	  fieldNames = u.getFieldNames();
	  queryProjection = "*";
	}
      
      ResultSet rs = u.records(queryProjection,"","lastname");

      //   if (rs.next()) System.out.println("not empty");
      //else System.out.println("*********EMPTY**************");
      /*try {
	Hashtable fields=new Hashtable();
	fields.put("gslogin","gslogin");
	RecordParser rparser=new RecordParser(rs, fieldNames);
	if(rparser != null) {// caller method may not provide a record parser! 
	  System.out.println("will---------- parse");
	  while( rparser.handleRecord(fields) ) {
	    //parseLine(fields, record, out); 
	    System.out.println("@");
	  }
	}
      }
      catch (Exception e)
	{System.out.println("big errororororo");}
	*/
      //System.out.println("PARSING");
      Parser.parseHtml(templateFile, ht, out,  new RecordParser(rs, fieldNames));
      //System.out.println("---PARSING---");
      //  ht.put("firstname","firstname");
      //  ht.put("gslogin","gslogin");
      //out.println("<p>testing..." +templateFile);      Parser.parseHtml(templateFile, ht, out	       );
      
      out.println("<p>testing..." +templateFile);
    } catch( Exception e ) {
      out.println("<h2>ERROR: "+e.getMessage()+"</h2>");
    }   
  }

  void browseUser (ServletOutputStream out, String templateFile, String gslogin) 
       throws IOException
  {
    if(gslogin.length() >= gUsers.MIN_LOGIN_NAME_LENGTH) {
      try {
	System.out.println("+--------------+++");
	Hashtable ht=dbUser.getFields( gslogin );
      String rcl=findRestrictedList((String)ht.get("ACL"));
      ht.put("rcl",rcl);
	System.out.println("--PRIVILIGE   "+(String)ht.get("privilige"));
	System.out.println("++++++++++++++++++");
	ht.put("host", "http://osprey7.npac.syr.edu:5757");
	ht.put("servlet", "GS");

	Parser.parseHtml(templateFile,ht , out);

      } catch(Exception e) {
	out.println("<h2>ERROR at browsing user "+gslogin+": "+e.getMessage()+"</h2>");
      }
    } else {
      out.println("<h2>ERROR:Illegal user login name '"+gslogin+"'.</h2>");
    }
  }
 void newUserFrame  (
		  ServletOutputStream out, 
		  String templateFile
		  )        throws IOException
  {
    try {
      Hashtable ht= new Hashtable();
      ht.put("host", "http://osprey7.npac.syr.edu:5757");
      ht.put("servlet", "GS");
   	ht.put("framecomm", "NEWRECORD");
      	ht.put("gslogin", "__new___");
      	ht.put("file", "new.html");

      Parser.parseHtml(templateFile, ht, out);
    } catch(Exception e) {
      out.println("<h2>ERROR:"+e.getMessage()+"</h2>");
    }
  }

  void newUserRecord(ServletOutputStream out, String templateFile) 
       throws IOException
  {
    try {
      Hashtable ht = dbUser.getEmptyFields();
      String rcl=findRestrictedList("");
      ht.put("rcl",rcl);
      ht.put("host", "http://osprey7.npac.syr.edu:5757");
      ht.put("servlet", "GS");

      Parser.parseHtml(templateFile, ht, out);
      
    } catch(Exception e) {
      out.println("<h2>ERROR:"+e.getMessage()+"</h2>");
    }
  }
  void editUserFrame  (
		  ServletOutputStream out, 
		  String templateFile, 
		  String gslogin
		  )        throws IOException
  {
    try {
      Hashtable ht= new Hashtable();
      ht.put("host", "http://osprey7.npac.syr.edu:5757");
      ht.put("servlet", "GS");
   	ht.put("framecomm", "EDITRECORD");
      	ht.put("gslogin", gslogin);
      	ht.put("file", "edit.html");

      Parser.parseHtml(templateFile, ht, out);
    } catch(Exception e) {
      out.println("<h2>ERROR:"+e.getMessage()+"</h2>");
    }
  }
  void editUserRecord  (
		  ServletOutputStream out, 
		  String templateFile, 
		  String gslogin
		  )        throws IOException
  {
    try {
      Hashtable ht=dbUser.getFields(gslogin);
      String rcl=findRestrictedList((String)ht.get("ACL"));
      ht.put("rcl",rcl);
      ht.put("host", "http://osprey7.npac.syr.edu:5757");
      ht.put("servlet", "GS");
      Parser.parseHtml(templateFile, ht, out);
    } catch(Exception e) {
      out.println("<h2>ERROR:"+e.getMessage()+"</h2>");
    }
  }

  void deleteUser
  (
   ServletOutputStream out, 
   String templateFile, String unum,
   String gslogin,
   String answer
    ) 
       throws IOException
  {
    try {
      Hashtable ht = new Hashtable();
      if(answer == null) 
	{
	int pos=templateFile.lastIndexOf( (int) '/');
	 templateFile=templateFile.substring(0,pos)+"/confirm.html";
	  ht.put("message", "<br>Do you really want to delete the user <i>"+gslogin+"</i>?");
	  ht.put("actionurl", "updatemessage.html");
	  ht.put("comm","DELETE");
	   ht.put("unum",unum);
	  ht.put("gslogin",gslogin);
	} 
      else if(answer.equals("YES")) 
	{
	  dbUser.delete(gslogin);
	  ht.put("message", "User information has been succesfully deleted!");
	}
      else if(answer.equals("NO")) {
	 out.println("<script language=JavaScript> history.go(-2);</script>");
      }
      Parser.parseHtml(templateFile, ht, out);
      
    } catch(Exception e) {
      out.println("<h2>ERROR:"+e.getMessage()+"</h2>");
    }
  }
  void addUser(
	       ServletOutputStream out, 
	       dbUser dbu,
	       String templateFile
	       )        throws IOException
    {
      try {
	Hashtable ht = new Hashtable();
	dbu.add();
      ht.put("host", "http://osprey7.npac.syr.edu:5757");
      ht.put("servlet", "GS");

	ht.put("message", "User addition comleted successfully!");
	ht.put("script", "");
	ht.put("framecomm", "SHOW");
	ht.put("gslogin", dbu.gslogin);
	ht.put("file", "browse.html");
	Parser.parseHtml(templateFile, ht, out);
	
      } catch( Exception e ) {
	out.println( Html.header("User Records") );
	String error =e.getMessage();
	if (error.indexOf("unique") >=0) {
	  error= new String("This user login id exists in the system. <br> Please try another one.");
	}
	out.println("<h2>ERROR: "+error);
	out.println("<HR>");
	out.println( Html.footer() );
      }   
    }
  void updateUser(
	       ServletOutputStream out, 
	       dbUser dbu,
	       String templateFile
	       )        throws IOException
    {
      try {
	Hashtable ht = new Hashtable();
	dbu.update();
      ht.put("host", "http://osprey7.npac.syr.edu:5757");
      ht.put("servlet", "GS");
	ht.put("message", "User addition comleted successfully!");
	ht.put("reload","YES");
	ht.put("framecomm", "SHOW");
	ht.put("gslogin", dbu.gslogin);
	ht.put("file", "browse.html");
	Parser.parseHtml(templateFile, ht, out);
	
      } catch( Exception e ) {
	out.println( Html.header("User Records") );
	String error =e.getMessage();
	if (error.indexOf("unique") >=0) {
	  error= new String("This user login id exists in the system. <br> Please try another one.");
	}
	out.println("<h2>ERROR: "+error);
	out.println("<HR>");
	out.println( Html.footer() );
      }   
    }
  void skip(ServletOutputStream out,String templateFile, String unum) throws IOException{
      try {
	int pos=templateFile.lastIndexOf( (int) '/');
	 templateFile=templateFile.substring(0,pos)+"/info.html";
    Hashtable ht = new Hashtable();
      ht.put("host", "http://osprey7.npac.syr.edu:5757");
      ht.put("servlet", "GS");
      ht.put("unum", unum);
    Parser.parseHtml(templateFile,ht,out);
      } catch( Exception e ) {
	out.println( Html.header("User Records") );
	String error =e.getMessage();
	if (error.indexOf("unique") >=0) {
	  error= new String("This user login id exists in the system. <br> Please try another one.");
	}
	out.println("<h2>ERROR: "+error);
	out.println("<HR>");
	out.println( Html.footer() );
      }   
  }
  void  decideFrame(ServletOutputStream out,String path,String  framecomm,
		    String file,String unum,String gslogin) throws IOException{
		      
		      System.out.println("<h1>"+unum+" "+gslogin);
      try {
	Hashtable ht = new Hashtable();
      ht.put("host", "http://osprey7.npac.syr.edu:5757");
      ht.put("servlet", "GS");
	ht.put("framecomm", framecomm);
	ht.put("file", file);
	ht.put("unum",unum);
	ht.put("gslogin",gslogin);
	Parser.parseHtml(path,ht,out);
      } catch( Exception e ) {
	 e.printStackTrace();
	out.println( Html.header("User Records") );
	String error =e.getMessage();
	out.println("<h2>ERROR: "+error+" at guser.frame");
	out.println("<HR>");
	out.println( Html.footer() );
      }   
  }


  } //class close
