package gs.admin;

import java.util.Hashtable;

import java.io.IOException;

import javax.servlet.Servlet;
import javax.servlet.ServletException;
import javax.servlet.ServletOutputStream;
import javax.servlet.ServletContext;
import javax.servlet.ServletConfig;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpUtils;


import gs.db.update;
import gs.db.dbUser;
import gs.db.groupusers;

import java.sql.ResultSet;

import gs.html.Html;
import gs.html.Parser;
import gs.html.RecordParser;


/**
 */
public class gUsers extends HttpServlet {

    /**
     * Service the request.
     *
     * @exception  ServletException if there is any sort of Exception
     *
     */

  public static int MIN_LOGIN_NAME_LENGTH = 3;
  public static int MIN_PASSWORD_LENGTH = 5;
  public gSystem  sys=new gSystem();



  public void doPost  (HttpServletRequest req,HttpServletResponse response) 
       throws IOException, ServletException 
  {
    processInOut( req,response);
  }

  public void doGet(HttpServletRequest req, HttpServletResponse response)
       throws IOException, ServletException
  {
    processInOut( req,response);
  }


  public void processInOut (HttpServletRequest req,HttpServletResponse response)
       throws IOException, ServletException
  {

    response.setStatus(HttpServletResponse.SC_OK); 
    response.setContentType("text/html");
    
    ServletOutputStream out = response.getOutputStream();
    String templateFile = req.getPathTranslated();
    String unum = req.getParameter("unum"); 
    String command = req.getParameter("comm"); 
    //    out.println( Html.header("User Records") );
    //    System.out.println( templateFile);


    try {
      if(command.equals("list"))
	listUsers(out, unum, req.getPathTranslated(), false);

      else if(command.equals("LISTALL"))
	listUsers(out, unum, req.getPathTranslated(), true);

      else if(command.equals("FRAME"))
	decideFrame(out, unum, req.getPathTranslated(), 
		    req.getParameter("framecomm"),
		    req.getParameter("file"), req.getParameter("gslogin"));

      else if(command.equals("SHOW"))
	browseUser(out, unum, req.getPathTranslated(), req.getParameter("gslogin"));

      else if(command.equals("NEW"))
	newUserFrame(out, unum, req.getPathTranslated());

      else if(command.equals("NEWRECORD"))
	newUserRecord(out, unum, req.getPathTranslated());

      else if(command.equals("SKIP"))
	skip(out, unum, req.getPathTranslated());

      else if(command.equals("CANCEL"))
	out.println("<script language=JavaScript> history.go(-2);</script>");

      else if(command.equals("EDIT"))
	editUserFrame(out, unum, req.getPathTranslated(),
		      (String)(req.getParameter("gslogin")));

      else if(command.equals("EDITRECORD"))
	editUserRecord(out, unum, req.getPathTranslated(),
		       (String)(req.getParameter("gslogin")));

      else if(command.equals("DELETE"))
	deleteUser(out, unum, req.getPathTranslated(),
		   (String)(req.getParameter("gslogin")), 
		   (String)(req.getParameter("answer")));

      else if(command.equals("UPDATE")) 
	updateUser(out, unum, readUserFields(req), req.getPathTranslated());

      else if(command.equals("ADD")) 
	addUser(out, unum, readUserFields(req), req.getPathTranslated());

    } catch (Exception e) {
      sys.error(out,e.getMessage());
    }

    //    out.println( Html.footer() );
    out.close();
  
  }


  //--------------------------------------------------------------------//
  //Reads User fields from the html request form
  //--------------------------------------------------------------------//
  public dbUser readUserFields(HttpServletRequest req) throws Exception {

    dbUser u=new dbUser();

    u.gslogin   = req.getParameter("gslogin"); 
    u.firstname = req.getParameter("firstname"); 
    u.midname   = req.getParameter("midname");
    u.lastname  = req.getParameter("lastname"); 
    u.gspwd     = req.getParameter("gspwd"); 
    String confirm   = req.getParameter("confirmgspwd"); 
      
    if(u.gslogin.equals("") || u.firstname.equals("") || u.lastname.equals("") 
       || u.gspwd.equals("") || confirm.equals("")) 
      throw new Exception("Please enter in all the fields in red!");
    else if (u.gslogin.length() < gUsers.MIN_LOGIN_NAME_LENGTH) 
      throw new Exception("Users' login names must be at least 3 digits long!");
    else if (!u.gspwd.equals(confirm)) 
      throw new Exception("Passwords do not match!");
    else if (u.gspwd.length() < gUsers.MIN_PASSWORD_LENGTH) 
      throw new Exception("Password must be at least 5 characters long!");
    else {
      u.idnum = req.getParameter("idnum");
      u.privilige = req.getParameter("privilige");
      u.ACL       = req.getParameter("access");
      u.email     = req.getParameter("email"); 
      u.dept      = req.getParameter("dept"); 
      u.url       = req.getParameter("url");  
      u.picurl    = req.getParameter("picurl");  
      u.phone     = req.getParameter("phone"); 
      u.room      = req.getParameter("room");  
      u.systemslogin   = req.getParameter("systemslogin");
      u.comments = req.getParameter("comments");
      u.reserved  = req.getParameter("reserved");
    }
      
    return u;

  }
  //--------------------------------------------------------------------//
  // findRestrictedList
  //--------------------------------------------------------------------//  
  public String findRestrictedList(String acl){
    return "<OPTION>me";
  }

  //--------------------------------------------------------------------//
  // List ALL users 
  //--------------------------------------------------------------------//  
  void listUsers(ServletOutputStream out, String unum, String templateFile, boolean allFields)
       throws Exception, IOException 
  {
      Hashtable ht = new Hashtable();
      sys.globalValues(ht,unum);

      String fieldNames = "gslogin,firstname,midname,lastname,url";
      String queryProjection = fieldNames;
      dbUser u = new dbUser();

      if(allFields) 	{
	fieldNames = u.getFieldNames();
	queryProjection = "*";
      }
      out.println("<h2> here");
	System.out.println("<h2> here");
      ResultSet rs = u.records(queryProjection,"","lastname");
      out.println("<h2> here");
	System.out.println("<h2> here");
      Parser.parseHtml(templateFile, ht, out,  new RecordParser(rs, fieldNames));
      out.println("<h2> here");
	System.out.println("<h2> here");

  }

  //--------------------------------------------------------------------//
  // Browse a user
  //--------------------------------------------------------------------//  
  void browseUser (ServletOutputStream out, String unum, String templateFile, String gslogin) 
       throws Exception, IOException
  {
    if(gslogin.length() >= gUsers.MIN_LOGIN_NAME_LENGTH) {
      try {
      Hashtable ht=dbUser.getFields( gslogin );
      String rcl=findRestrictedList((String)ht.get("ACL"));
      sys.globalValues(ht,unum);
      ht.put("rcl",rcl);
      Parser.parseHtml(templateFile,ht , out);
      
      } catch(Exception e) {
	throw new Exception("<h2>ERROR at browsing user "+gslogin+": "+e.getMessage()+"</h2>");
      }
    } else {
      throw new Exception("<h2>ERROR:Illegal user login name '"+gslogin+"'.</h2>");
    }
  }

  //--------------------------------------------------------------------//
  // open new user page using frames
  //--------------------------------------------------------------------//  
  void newUserFrame  (ServletOutputStream out, String unum, String templateFile)
       throws  Exception, IOException
  {
      Hashtable ht= new Hashtable();
      sys.globalValues(ht,unum);
      ht.put("framecomm", "NEWRECORD");
      ht.put("gslogin", "__new___");
      ht.put("file", "new.html");
      Parser.parseHtml(templateFile, ht, out);
  }

  //--------------------------------------------------------------------//
  // open new user record form in a frame 
  //--------------------------------------------------------------------//  
  void newUserRecord(ServletOutputStream out, String unum, String templateFile) 
       throws Exception, IOException
  {
      Hashtable ht = dbUser.getEmptyFields();
      sys.globalValues(ht,unum);
      String rcl=findRestrictedList("");
      ht.put("rcl",rcl);
      Parser.parseHtml(templateFile, ht, out);
  }

  //--------------------------------------------------------------------//
  // open the page to  edit an existing user
  //--------------------------------------------------------------------//  
  void editUserFrame (ServletOutputStream out, String unum, 
		      String templateFile, String gslogin)        
       throws Exception,IOException
  {
      Hashtable ht= new Hashtable();
      sys.globalValues(ht,unum);
      ht.put("framecomm", "EDITRECORD");
      ht.put("gslogin", gslogin);
      ht.put("file", "edit.html");
      Parser.parseHtml(templateFile, ht, out);
  }
  //--------------------------------------------------------------------//
  //  editUserRecord page
  //--------------------------------------------------------------------//  
  void editUserRecord (ServletOutputStream out, String unum, 
		       String templateFile, String gslogin)        
       throws  Exception, IOException
  {
      Hashtable ht=dbUser.getFields(gslogin);
      sys.globalValues(ht,unum);
      String rcl=findRestrictedList((String)ht.get("ACL"));
      ht.put("rcl",rcl);
      Parser.parseHtml(templateFile, ht, out);
  }

  //--------------------------------------------------------------------//
  // DELETE a user
  //--------------------------------------------------------------------//  
  void deleteUser (ServletOutputStream out, String unum,
		   String templateFile, String gslogin, String answer) 
       throws Exception, IOException
  {
      Hashtable ht = new Hashtable();
      sys.globalValues(ht,unum);
      if(answer == null) {
	int pos=templateFile.lastIndexOf( (int) '/');
	templateFile=templateFile.substring(0,pos)+"/confirm.html";
	ht.put("message", "<br>Do you really want to delete the user <i>"+gslogin+"</i>?");
	ht.put("actionurl", "updatemessage.html");
	ht.put("comm","DELETE");	
	ht.put("gslogin",gslogin);
      } 
      else if(answer.equals("YES")) {
	dbUser.delete(gslogin);
	ht.put("message", "User information has been succesfully deleted!");
      }
      else if(answer.equals("NO")) {
	out.println("<script language=JavaScript> history.go(-2);</script>");
      }
      Parser.parseHtml(templateFile, ht, out);
      
  }

  //--------------------------------------------------------------------//
  // add new User
  //--------------------------------------------------------------------//  
  void addUser(ServletOutputStream out, String unum, dbUser dbu, String templateFile )
       throws Exception,IOException
  {
    try {
      Hashtable ht = new Hashtable();
      sys.globalValues(ht,unum);
      dbu.add();
      ht.put("message", "User addition comleted successfully!");
      ht.put("script", "");
      ht.put("framecomm", "SHOW");
      ht.put("gslogin", dbu.gslogin);
      ht.put("file", "browse.html");
      Parser.parseHtml(templateFile, ht, out);
	
    } catch( Exception e ) {
      String error =e.getMessage();
      if (error.indexOf("unique") >=0) {
	error= new String("This user login id exists in the system. <br> Please try another one.");
	}
      throw new Exception(error);
    }    
  }
  //--------------------------------------------------------------------//
  // update user record 
  //--------------------------------------------------------------------//  

  void updateUser(ServletOutputStream out, String unum, dbUser dbu,String templateFile)
       throws Exception,IOException
    {
      try {
	Hashtable ht = new Hashtable();
	sys.globalValues(ht,unum);
	dbu.update();
	ht.put("message", "User addition comleted successfully!");
	ht.put("reload","YES");
	ht.put("framecomm", "SHOW");
	ht.put("gslogin", dbu.gslogin);
	ht.put("file", "browse.html");
	Parser.parseHtml(templateFile, ht, out);
	
      } catch( Exception e ) {
	out.println( Html.header("User Records") );
	String error =e.getMessage();
	if (error.indexOf("unique") >=0) {
	  error= new String("This user login id exists in the system. <br> Please try another one.");
	}
	throw new Exception(error);
      }   
    }
  //--------------------------------------------------------------------//
  // 
  //--------------------------------------------------------------------//  
  void skip(ServletOutputStream out, String unum,String templateFile) 
       throws Exception,IOException
  {
      int pos=templateFile.lastIndexOf( (int) '/');
      templateFile=templateFile.substring(0,pos)+"/info.html";
      Hashtable ht = new Hashtable();
      sys.globalValues(ht,unum);
      Parser.parseHtml(templateFile,ht,out);
  }
  //--------------------------------------------------------------------//
  // 
  //--------------------------------------------------------------------//  
  void  decideFrame(ServletOutputStream out, String unum ,String path,
		    String  framecomm, String file, String gslogin) 
       throws  Exception,IOException
  {
    try {
      Hashtable ht = new Hashtable();
      sys.globalValues(ht,unum);
	ht.put("framecomm", framecomm);
	ht.put("file", file);
	ht.put("gslogin",gslogin);
	Parser.parseHtml(path,ht,out);
    } catch( Exception e ) {
      e.printStackTrace();
      out.println( Html.header("User Records") );
      String error =e.getMessage();
      out.println("<h2>ERROR: "+error+" at guser.frame");
      out.println("<HR>");
      out.println( Html.footer() );
    }   
  }


} //class close

