
package gs.admin;

import java.util.Hashtable;

import java.io.IOException;

import javax.servlet.Servlet;
import javax.servlet.ServletException;
import javax.servlet.ServletOutputStream;
import javax.servlet.ServletContext;
import javax.servlet.ServletConfig;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpUtils;

import java.sql.ResultSet;

import gs.db.update;
import gs.db.course;

import gs.html.Html;
import gs.html.Parser;
import gs.html.RecordParser;

/**
 */
public class courses extends HttpServlet {

    /**
     * Service the request.
     *
     * @exception  ServletException if there is any sort of Exception
     *
     */
  public void doPost
  (
   HttpServletRequest req,
   HttpServletResponse response
    )
       throws IOException, ServletException
  {
    response.setStatus(HttpServletResponse.SC_OK); 
    response.setContentType("text/html");
    
    ServletOutputStream out = response.getOutputStream();
    
    out.println( Html.header("Course Addition") );
    
    String command   = req.getParameter("comm");

    String reference = req.getParameter("reference");
    String code  = req.getParameter("code"); 
    String term  = req.getParameter("term");
    String year  = req.getParameter("year"); 
    
    if(reference.equals("") || code.equals("") || term.equals("") 
       || year.equals("")) 
      out.println("<h2>ERROR: Please enter in all the fields in red!</h2>");
    else {
      String title   = req.getParameter("title"); 
      String days    = req.getParameter("days"); 
      String times   = req.getParameter("times"); 
      String room    = req.getParameter("room"); 
      String grading = req.getParameter("grading"); 
      String url     = req.getParameter("url"); 
      String comments= req.getParameter("comments"); 
      
      course c = new course(reference, code, term, year, title, 
			    days, times, room, grading, url, comments );  

      try {
	String templateFile = req.getPathTranslated();
	Hashtable ht = new Hashtable();

	if( command.equals("new") ) {
	  update.updateData( c.insertSQL() );
	  ht.put("message", "Course addition comleted successfully!");
	} 
	else {
	  update.updateData( c.updateSQL() );
	  ht.put("message", "Course information update comleted successfully!");
	}

	Parser.parseHtml(templateFile, ht, out);
	
      } catch( Exception e ) {
	out.println("<h2>ERROR: "+e.getMessage());
      }   
      
      out.println( Html.footer() );
    }
  }

  public void doGet(HttpServletRequest req, HttpServletResponse response)
       throws IOException, ServletException
  {
    
    response.setStatus(HttpServletResponse.SC_OK); 
    response.setContentType("text/html");
    
    ServletOutputStream out = response.getOutputStream();
    
    out.println( Html.header("Course Records") );
    
    String command= req.getParameter("comm"); 
    if(command.equals("list"))
      listCourses(out, req.getPathTranslated(), false);
      
    else if(command.equals("listall"))
      listCourses(out, req.getPathTranslated(), true);

    else if(command.equals("browse"))
      browseCourse(out, req.getPathTranslated(), req.getParameter("course"));

    else if(command.equals("new"))
      newCourse(out, req.getPathTranslated());

    else if(command.equals("delete"))
      deleteCourse(out, req.getPathTranslated(), 
		   (String)(req.getParameter("course")), 
		   (String)(req.getParameter("answer")));
    
    out.println( Html.footer() );
    out.close();
  }

  void listCourses(ServletOutputStream out, 
		   String templateFile, 
		   boolean allFields)
       throws IOException
  {    
    try 
      {
	Hashtable ht = new Hashtable();
	
	StringBuffer output = new StringBuffer();
	String fieldNames = "reference,code,term,year";
	
	String queryProjection = fieldNames;
	course c = new course();

	if(allFields) 
	  {
	    fieldNames = c.getFieldNames();
	    queryProjection = "*";
	  }
	
	ResultSet rs = c.records(queryProjection,"","code,year");
	Parser.parseHtml(templateFile, ht, out, 
			 new RecordParser(rs, fieldNames));
	
	out.println("<p>testing...");
      } catch( Exception e ) {
	out.println("<h2>ERROR: "+e.getMessage()+"</h2>");
      }   
  }
  
  void browseCourse(ServletOutputStream out, String templateFile, String reference) 
       throws IOException
  {
    try {
      Hashtable ht = course.getFields(reference);
      Parser.parseHtml(templateFile, ht, out);
      
    } catch(Exception e) {
      out.println("<h2>ERROR:"+e.getMessage()+"</h2>");
    }
  }

  void newCourse(ServletOutputStream out, String templateFile)
       throws IOException
  {
    try {
      Hashtable ht = course.getEmptyFields();
      Parser.parseHtml(templateFile, ht, out);
      
    } catch(Exception e) {
      out.println("<h2>ERROR:"+e.getMessage()+"</h2>");
    }
  }

  void deleteCourse
  (
   ServletOutputStream out, 
   String templateFile, 
   String reference,
   String answer
    ) 
       throws IOException
  {
    try {
      Hashtable ht = new Hashtable();
      if(answer == null) 
	{
	  ht.put("message", "Do you really want to delete the course <i>"+reference+"</i>?");
	  ht.put("actionurl", "message.html");
	  ht.put("comm","delete");
	  ht.put("course",reference);
	} 
      else if(answer.equals("YES")) 
	{
	  update.updateData( course.delete(reference) );
	  ht.put("message", "Course information has been succesfully deleted!");
	}
      Parser.parseHtml(templateFile, ht, out);
      
    } catch(Exception e) {
      out.println("<h2>ERROR:"+e.getMessage()+"</h2>");
    }
  }


}
