package gs.admin;

import java.util.Enumeration;
import java.util.Hashtable;
import java.util.StringTokenizer;

import java.io.IOException;

import javax.servlet.Servlet;
import javax.servlet.ServletException;
import javax.servlet.ServletOutputStream;
import javax.servlet.ServletContext;
import javax.servlet.ServletConfig;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpUtils;

import java.sql.ResultSet;
import java.sql.SQLException;

import gs.db.update;
import gs.db.student;
//import gs.db.user;    // remove this later...
import gs.db.groupusers;
//import gs.db.RecordHandler;

import gs.html.Html;
import gs.html.Parser;
import gs.html.RecordParser;

/**
 */
public class students extends HttpServlet {

    /**
     * Service the request.
     *
     * @exception  ServletException if there is any sort of Exception
     *
     */

  public static int MIN_SSN_LENGTH = 9;
  public static int MIN_PASSWORD_LENGTH = 5;

  private final String DEFAULT_USER_GROUP = "students";
  
  public void doPost
  (
   HttpServletRequest req,
   HttpServletResponse response
    )
       throws IOException, ServletException
  {
    
    response.setStatus(HttpServletResponse.SC_OK); 
    response.setContentType("text/html");
    
    ServletOutputStream out = response.getOutputStream();

    out.println( Html.header("Student Addition") );
    
    String command   = req.getParameter("comm");
    String ssn       = req.getParameter("ssn1")
                       +req.getParameter("ssn2")
                       +req.getParameter("ssn3"); 
    String firstname = req.getParameter("firstname"); 
    String midname   = req.getParameter("midname");
    String lastname  = req.getParameter("lastname"); 
    String gspwd     = req.getParameter("gspwd"); 
    String confirm   = req.getParameter("confirmgspwd"); 

    if(ssn.equals("") || firstname.equals("") || lastname.equals("") 
       || gspwd.equals("") || confirm.equals("")) 
      out.println("<h2>ERROR: Please enter in all the fields in red!");
    else if (ssn.length() != students.MIN_SSN_LENGTH) 
      out.println("<h2>ERROR: Social security number must be 9 digits long!");
    else if (!gspwd.equals(confirm)) 
      out.println("<h2>ERROR: Passwords do not match!");
    else if (gspwd.length() < students.MIN_PASSWORD_LENGTH) 
      out.println("<h2>ERROR: Password must be at least 5 characters long!");
    else {
      String student_id= req.getParameter("student_id"); 
      String email     = req.getParameter("email"); 
      String dept      = req.getParameter("dept"); 
      String year      = req.getParameter("year"); 
      String login     = req.getParameter("login"); 
      String unixpwd   = "";
      String url       = req.getParameter("url");  

      student s = new student(ssn, gspwd, firstname, midname, lastname,
			      student_id, email, dept, year, login, unixpwd, url);  
      groupusers gu = new groupusers(DEFAULT_USER_GROUP, ssn);  
      
      try {
	String templateFile = req.getPathTranslated();
	Hashtable ht = new Hashtable();

	if( command.equals("new") ) {
	  update.updateData( s.insertSQL() );
	  update.updateData( gu.insertSQL() );
	  ht.put("message", "Student addition comleted successfully!");
	} 
	else {
	  update.updateData( s.updateSQL() );
	  ht.put("message", "Student information update comleted successfully!");
	}

	Parser.parseHtml(templateFile, ht, out);
	
      } catch( Exception e ) {
	out.println("<h2>ERROR: "+e.getMessage());
      }   
      
      out.println( Html.footer() );
    }
  }
  
  public void doGet(HttpServletRequest req, HttpServletResponse response)
       throws IOException, ServletException
  {
    
    response.setStatus(HttpServletResponse.SC_OK); 
    response.setContentType("text/html");
    
    ServletOutputStream out = response.getOutputStream();
    
    out.println( Html.header("Student Records") );
    
    String command= req.getParameter("comm"); 
    if(command.equals("list"))
      listStudents(out, req.getPathTranslated(), false);
      
    else if(command.equals("listall"))
      listStudents(out, req.getPathTranslated(), true);

    else if(command.equals("browse"))
      browseStudent(out, req.getPathTranslated(), req.getParameter("user"));

    else if(command.equals("new"))
      newStudent(out, req.getPathTranslated());

    else if(command.equals("delete"))
      deleteStudent(out, req.getPathTranslated(), 
		    (String)(req.getParameter("user")), 
		    (String)(req.getParameter("answer")));

    out.println( Html.footer() );
    out.close();
  }

  void listStudents(ServletOutputStream out, 
		    String templateFile, 
		    boolean allFields)
       throws IOException
  {    
    try 
      {
	Hashtable ht = new Hashtable();
	
	StringBuffer output = new StringBuffer();
	String fieldNames = "ssn,firstname,midname,lastname";
	
	String queryProjection = fieldNames;
	student s = new student();

	if(allFields) 
	  {
	    fieldNames = s.getFieldNames();
	    queryProjection = "*";
	  }
	
	ResultSet rs = s.records(queryProjection,"","lastname");
	Parser.parseHtml(templateFile, ht, out, 
			 new RecordParser(rs, fieldNames));
	
	out.println("<p>testing...");
      } catch( Exception e ) {
	out.println("<h2>ERROR: "+e.getMessage()+"</h2>");
      }   
  }
  
  void browseStudent(ServletOutputStream out, String templateFile, String ssn) 
       throws IOException
  {
    if(ssn.length() >= students.MIN_SSN_LENGTH) {
      try {
	Hashtable ht = student.getFields(ssn);
	ht.put("ssn1", ssn.substring(0,3));
	ht.put("ssn2", ssn.substring(3,5));
	ht.put("ssn3", ssn.substring(5));
	Parser.parseHtml(templateFile, ht, out);

      } catch(Exception e) {
	out.println("<h2>ERROR:"+e.getMessage()+"</h2>");
      }
    } else {
      out.println("<h2>ERROR:Illegal SSN '"+ssn+"'.</h2>");
    }
  }

  void newStudent(ServletOutputStream out, String templateFile)
       throws IOException
  {
    try {
      Hashtable ht = student.getEmptyFields();
      ht.put("ssn1", "");
      ht.put("ssn2", "");
      ht.put("ssn3", "");
      ht.put("year0", "");
      ht.put("year1", "");
      ht.put("year2", "");
      ht.put("year3", "");
      ht.put("year4", "");
      ht.put("year5", "SELECTED");
      ht.put("year6", "");
      ht.put("year7", "");
      ht.put("comm", "new");
      
      Parser.parseHtml(templateFile, ht, out);
      
    } catch(Exception e) {
      out.println("<h2>ERROR:"+e.getMessage()+"</h2>");
    }
  }

  void deleteStudent
  (
   ServletOutputStream out, 
   String templateFile, 
   String ssn,
   String answer
    ) 
       throws IOException
  {
    try {
      Hashtable ht = new Hashtable();
      if(answer == null) 
	{
	  ht.put("message", "Do you really want to delete the student <i>"+ssn+"</i>?");
	  ht.put("actionurl", "message.html");
	  ht.put("comm","delete");
	  ht.put("user",ssn);
	} 
      else if(answer.equals("YES")) 
	{
	  groupusers gu = new groupusers( "", ssn );
	  
	  update.updateData( student.delete(ssn) );
	  update.updateData( gu.deleteSQL() );
	  ht.put("message", "User information has been succesfully deleted!");
	}
      Parser.parseHtml(templateFile, ht, out);
      
    } catch(Exception e) {
      out.println("<h2>ERROR:"+e.getMessage()+"</h2>");
    }
  }
}
