package gs.admin;

import java.util.Hashtable;

import java.io.IOException;

import javax.servlet.Servlet;
import javax.servlet.ServletException;
import javax.servlet.ServletOutputStream;
import javax.servlet.ServletContext;
import javax.servlet.ServletConfig;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpUtils;

import java.sql.ResultSet;

import gs.db.update;
import gs.db.user;
import gs.db.groupusers;

import gs.html.Html;
import gs.html.Parser;
import gs.html.RecordParser;

/**
 */
public class users extends HttpServlet {

    /**
     * Service the request.
     *
     * @exception  ServletException if there is any sort of Exception
     *
     */

  public static int MIN_LOGIN_NAME_LENGTH = 3;
  public static int MIN_PASSWORD_LENGTH = 5;

  private final String DEFAULT_USER_GROUP = "users";
  
  public void doPost
  (
   HttpServletRequest req,
   HttpServletResponse response
    )
       throws IOException, ServletException
  {
    
    response.setStatus(HttpServletResponse.SC_OK); 
    response.setContentType("text/html");
    
    ServletOutputStream out = response.getOutputStream();
    
    out.println( Html.header("User Addition") );
    
    String command   = req.getParameter("comm");

    String login_name= req.getParameter("user"); 
    String firstname = req.getParameter("firstname"); 
    String midname   = req.getParameter("midname");
    String lastname  = req.getParameter("lastname"); 
    String gspwd     = req.getParameter("gspwd"); 
    String confirm   = req.getParameter("confirmgspwd"); 
    
    if(login_name.equals("") || firstname.equals("") || lastname.equals("") 
       || gspwd.equals("") || confirm.equals("")) 
      out.println("<h2>ERROR: Please enter in all the fields in red!");
    else if (login_name.length() < users.MIN_LOGIN_NAME_LENGTH) 
      out.println("<h2>ERROR: Users' login names must be at least 3 digits long!");
    else if (!gspwd.equals(confirm)) 
      out.println("<h2>ERROR: Passwords do not match!");
    else if (gspwd.length() < users.MIN_PASSWORD_LENGTH) 
      out.println("<h2>ERROR: Password must be at least 5 characters long!");
    else {
      String email     = req.getParameter("email"); 
      String dept      = req.getParameter("dept"); 
      String NPAClogin = req.getParameter("login"); 
      String url       = req.getParameter("url");  
      String picurl    = req.getParameter("picurl");  
      String phone     = req.getParameter("phone"); 
      String room      = req.getParameter("room");  
      
      user u = new user(login_name, gspwd, firstname, midname, lastname,
			email, dept, NPAClogin, url, picurl, phone, room);  
      groupusers gu = new groupusers(DEFAULT_USER_GROUP, login_name);  
      
      try {
	String templateFile = req.getPathTranslated();
	Hashtable ht = new Hashtable();
	if( command.equals("new") ) {
	  update.updateData( u.insertSQL() );
	  update.updateData( gu.insertSQL() );
	  ht.put("message", "User addition comleted successfully!");
	} 
	else {
	  update.updateData( u.updateSQL() );
	  ht.put("message", "User information update comleted successfully!");
	}

	Parser.parseHtml(templateFile, ht, out);

      } catch( Exception e ) {
	out.println("<h2>ERROR:> "+e.getMessage());
      }   
      out.println("<HR>");
      
      out.println( Html.footer() );
    }
  }
  
  public void doGet(HttpServletRequest req, HttpServletResponse response)
       throws IOException, ServletException
  {
    
    response.setStatus(HttpServletResponse.SC_OK); 
    response.setContentType("text/html");
    
    ServletOutputStream out = response.getOutputStream();
    
    out.println( Html.header("User Records") );
    
    String command= req.getParameter("comm"); 
    System.out.println("Mehmet "+command);
    if(command.equals("list"))
      listUsers(out, req.getPathTranslated(), false);
      
    else if(command.equals("listall"))
      listUsers(out, req.getPathTranslated(), true);

    else if(command.equals("browse"))
      browseUser(out, req.getPathTranslated(), req.getParameter("user"));

    else if(command.equals("new"))
      newUser(out, req.getPathTranslated());

    else if(command.equals("delete"))
      deleteUser(out, req.getPathTranslated(), 
		 (String)(req.getParameter("user")), (String)(req.getParameter("answer")));

    System.out.println("Sen "+command);
    out.println( Html.footer() );
    System.out.println("-Sen- "+command);
    out.close();
    System.out.println("_Sen- "+command);
  }
  
  void listUsers(ServletOutputStream out, 
		 String templateFile, 
		 boolean allFields)
       throws IOException
  {

    try {
      Hashtable ht = new Hashtable();
      
      StringBuffer output = new StringBuffer();
      String fieldNames = "login,firstname,midname,lastname";

      String queryProjection = fieldNames;
      user u = new user();

      if(allFields) 
	{
	  fieldNames = u.getFieldNames();
	  queryProjection = "*";
	}

      ResultSet rs = u.records(queryProjection,"","lastname");
      Parser.parseHtml(templateFile, ht, out, 
		       new RecordParser(rs, fieldNames));
      
      out.println("<p>testing...");
    } catch( Exception e ) {
      out.println("<h2>ERROR: "+e.getMessage()+"</h2>");
    }   
  }

  void browseUser(ServletOutputStream out, String templateFile, String userlogin) 
       throws IOException
  {
    if(userlogin.length() >= users.MIN_LOGIN_NAME_LENGTH) {
      try {
	Parser.parseHtml(templateFile, user.getFields( userlogin ), out);

      } catch(Exception e) {
	out.println("<h2>ERROR:"+e.getMessage()+"</h2>");
      }
    } else {
      out.println("<h2>ERROR:Illegal user login name '"+userlogin+"'.</h2>");
    }
  }

  void newUser(ServletOutputStream out, String templateFile) 
       throws IOException
  {
    try {
      Hashtable ht = user.getEmptyFields();
      ht.put("comm", "new");
      
      Parser.parseHtml(templateFile, ht, out);
      
    } catch(Exception e) {
      out.println("<h2>ERROR:"+e.getMessage()+"</h2>");
    }
  }

  void deleteUser
  (
   ServletOutputStream out, 
   String templateFile, 
   String userlogin,
   String answer
    ) 
       throws IOException
  {
    try {
      Hashtable ht = new Hashtable();
      if(answer == null) 
	{
	  ht.put("message", "Do you really want to delete the user <i>"+userlogin+"</i>?");
	  ht.put("actionurl", "message.html");
	  ht.put("comm","delete");
	  ht.put("user",userlogin);
	} 
      else if(answer.equals("YES")) 
	{
	  groupusers gs = new groupusers( "", userlogin );
	  
	  update.updateData( user.delete(userlogin) );
	  update.updateData( gs.deleteSQL() );
	  ht.put("message", "User information has been succesfully deleted!");
	}
      Parser.parseHtml(templateFile, ht, out);
      
    } catch(Exception e) {
      out.println("<h2>ERROR:"+e.getMessage()+"</h2>");
    }
  }
}
