package gs.cache;

import java.util.Hashtable;

import java.io.IOException;
import javax.servlet.ServletException;

import javax.servlet.ServletOutputStream;


import gs.html.Html;
import gs.html.Parser;
import gs.html.RecordParser;

import gs.cache.StudentCache;

//import java.util.Date;
import java.util.Random;
import gs.db.dbStudent;


import java.text.DateFormat;
import java.util.Date;
import java.util.Calendar;


class ID {
  public long expire;
  public String accesscode;
  ID(){}
}

public class StudentCache {
  static int miss=0;
  static int hit=0;
  public static int size=100;
  static Hashtable studentht=new Hashtable(size);  //accesscode, student
  static Hashtable IDht=new Hashtable(size);      // ID, accesscode
  static Hashtable index=new Hashtable(size);   //Integer,accesscode
  static int counter=0;
  public static int EXPIRE=3600000; //1 hour;
  private static Random IDGenerator=new Random();

  public StudentCache(){  }
 //--------------------------------------------------------------------//
  // LOAD putIntoCache
  //--------------------------------------------------------------------//
  public synchronized static  void putIntoCache(String accesscode , dbStudent s){
    try {
      String oldacode=(String)index.get(Integer.toString(counter));
      dbStudent os=(dbStudent) studentht.get(oldacode);
      // String idnum= id.substring(0,id.indexOf((int) 'Z'));
      
      os.makeIDHardCopy(  );
      IDht.remove(os.idnum);
      studentht.remove(oldacode); 
    }
    catch (Exception e) {//System.out.println(" not existing");
    } 
    index.put(Integer.toString(counter),accesscode);
    studentht.put(accesscode,s);

    putIDIntoCache(accesscode,s);

  
    counter++;
    counter%=size;
  }
 //--------------------------------------------------------------------//
  // LOAD  putIDIntoCache
  //--------------------------------------------------------------------//
  public synchronized static void  putIDIntoCache(String accesscode, dbStudent s){

    ID id=new ID();
    // Date d=new Date();
 
    //  long now=d.getTime();

    //String idnum= s.idnum.substring(0,id.indexOf((int) 'Z')); System.out.println("Ceck z"+ idnum);
    //  long expire = now + EXPIRE;
    
    id.accesscode=accesscode  ;
    // s.expire=id.expire=expire;
    IDht.put(s.idnum, id);
  }
  //--------------------------------------------------------------------//
  //LOAD  updateCacheID
  //--------------------------------------------------------------------//
  public  static void    updateCacheID( String oldidnum,String newidnum,dbStudent s) {
    try { IDht.remove(oldidnum);} catch (Exception e) {}
    s.idnum=newidnum;
    putIDIntoCache(s.accesscode,s);
    
  }


  //--------------------------------------------------------------------//
  //LOAD  loadCacheFromID
  //--------------------------------------------------------------------//
  public static String loadCacheFromID(String ids) throws Exception{

    try {
      dbStudent s=dbStudent.findbyIdNumber(ids);
      putIntoCache(s.accesscode,s);
      return s.accesscode;
    } catch (Exception e) {
      throw new Exception("Illegal ID checked!.");
    }
  }

 //--------------------------------------------------------------------//
  // extendExpiration
  //--------------------------------------------------------------------//
  public  static void extendExpiration(String ids, dbStudent s) throws Exception{

    Date d=new Date();
    long now=d.getTime();

    long expire = now + EXPIRE;
    
    ID id = (ID)IDht.get(ids);   // assuming always in the cache
    s.expire=id.expire=expire;

  }

  //--------------------------------------------------------------------//
  // checkExpiration
  //--------------------------------------------------------------------//
  public  static void checkExpiration(long time) throws Exception{

    Date d=new Date();
    long now=d.getTime();
   
    if (time < now)
      throw new Exception(" Expired ID checked!.");
  }
  
  //--------------------------------------------------------------------//
  // findAccessNumber(String ids)                  GET id
  //--------------------------------------------------------------------//
  public  static String findAccessNumber(String ids) throws Exception {
    ID id = (ID)IDht.get(ids);
    if (id==null){
      return loadCacheFromID(ids);
    }
    return id.accesscode;
  }


  //--------------------------------------------------------------------//
  // getbyID getbyID getbyID getbyID getbyID getbyID getbyID getbyID
  //--------------------------------------------------------------------//
  public  static dbStudent getbyID( String id)    throws Exception , IOException 
  {
    String accesscode=findAccessNumber(id);
    dbStudent s=get(accesscode);
    checkExpiration(s.expire);
    extendExpiration(id,s);
    return s;
  }
   
//--------------------------------------------------------------------//
  // revert                                      REVERT 
  //--------------------------------------------------------------------//
  public  static void  revert( String accesscode)    throws Exception , IOException 
  {

    dbStudent s= (dbStudent)studentht.get(accesscode);
    if (s!=null) {
      studentht.remove(accesscode); 
    }
  }
    

  //--------------------------------------------------------------------//
  //dbStudent get( String accesscode)                 GET 
  //--------------------------------------------------------------------//
  public  static dbStudent get( String accesscode)    throws Exception , IOException 
  {
    dbStudent u= (dbStudent)studentht.get(accesscode);
    if (u==null) {
      try {
	//System.out.println("accesscode=========="+accesscode);
	u= new dbStudent(accesscode);
	//System.out.println("accesscode=========="+accesscode);
	putIntoCache(accesscode,u); 
	miss++;
      } catch (Exception e) {
	//System.out.println("Cache returning error for accesscode"+accesscode);
	throw e;
      }
    } else {
      hit++;
    }
    //System.out.println("==========student=============");
    //System.out.println("MISS "+miss+ " HIT "+hit);
    return u;
  }
  //--------------------------------------------------------------------//
  //  accessCheck
  //--------------------------------------------------------------------//

  public static String  accessCheck(String course,String accesscode,String gspwd)  throws Exception
  {
    //  if (true)
    //  return "dsfdf++++++++++++++++++++++";
    // Random r=new Random(); // replaced by IDGenerator to prevent any guess by attackers
 //System.out.println("check -1");

    dbStudent s = get(accesscode);

 //System.out.println("check 0");
 //System.out.println("s.gspwd+"+s.gspwd+"+"+gspwd+"+");
 //System.out.println("s.course+"+s.course+"+"+course+"+");

    if (!gspwd.equals(s.gspwd) || !course.equals( s.course) )
      throw new Exception ("GS:accesscheck:DENY");

 //System.out.println("check 1");

    String ids=getNextID();

 //System.out.println("check 2 "+ids);

 
    updateCacheID(s.idnum,ids,s);
 //System.out.println("check 2 3 "+ids);
    extendExpiration(ids,s);
 //System.out.println("check 3 "+ids);

    return ids;

    // while (existId(ids,accesscode))
    //  ids=Long.toString(r.nextLong()); // +"Z"+expiration;
    
  }
  public synchronized static String getNextID(){
    Date d=new Date();
    long now=d.getTime();
    long id=IDGenerator.nextLong();
    String ids= Long.toString(id)+Long.toString(now) ; //+"Z"+ expiration;
    return ids;
  }
  
  /*
  //--------------------------------------------------------------------//
  //existId(long id)
  //--------------------------------------------------------------------//
    public static boolean existId(String id,String accesscode) throws Exception {
    String accesscodeDB=dbStudent.checkStudentID(idnum);
    if (accesscodeDB==null ||accesscodeDB==accesscode) {
      //check cach also
      return false;
    }
    return true;
  }
  */
  /*   //--------------------------------------------------------------------//
  //setIdNumber(  String accesscode,dbStudent u) 
  //--------------------------------------------------------------------//
  public synchronized static void setID(  String accesscode,dbStudent u) 
       throws Exception {

         Date d=new Date();
         long now=d.getTime();
 
         long idtime=getIdNum(u.idnum);

         //      if (now < idtime) //not expired 
         //  return;
         //idht.remove(u.idnum);

         now += EXPIRE;
         String expiration=Long.toString(now);
         
         Random r=new Random();
         long id=r.nextLong();
         String ids=Long.toString(r.nextLong()) +"Z"+expiration;
         while (existId(ids,accesscode))
           ids=Long.toString(r.nextLong()) +"Z"+expiration;

         u.setidnum(ids);             //update DB
         idht.put(ids,accesscode);  //put into id hash
  }
//--------------------------------------------------------------------//
  //checkIdExpiration(String accesscode)
  //--------------------------------------------------------------------//
 
  public  static synchronized  boolean checkExpiration(String  id){
     Date d=new Date();
     long now=d.getTime();

     String timeString= id.substring(id.indexOf((int) 'Z')+1);
     long expire = Long.parseLong(timeString);
     
     return (expire <now);
  }

  */

  /* //--------------------------------------------------------------------//
  // Browse a student
  //--------------------------------------------------------------------//  
  public static dbStudent getStudent(String accesscode)  throws Exception
  {
    dbStudent u=(dbStudent) studentht.get(accesscode);
    if (u==null) {
      u= new dbStudent(accesscode);
      studentht.put(accesscode,u);
    }
    return u;
  }*/


  //--------------------------------------------------------------------//
  //--------------------------------------------------------------------//
  //--------------------------------------------------------------------//
  //--------------------------------------------------------------------//


  //--------------------------------------------------------------------//
  // delete student
  //--------------------------------------------------------------------//  
 
  public static void  delete(String accesscode)  throws Exception
  {
    dbStudent.delete(accesscode);
    studentht.remove(accesscode);
  }
  //--------------------------------------------------------------------//
  // add student
  //--------------------------------------------------------------------//  
 
  public static void  add(dbStudent dbu)  throws Exception
  {
    dbu.add();
    studentht.put(dbu.accesscode,dbu);
  }
  //--------------------------------------------------------------------//
  // update student
  //--------------------------------------------------------------------//  
 
  public static void  update(dbStudent dbu)  throws Exception
  {
    studentht.remove(dbu.accesscode);
    dbu.setIdentification();
    dbu.update();
    studentht.put(dbu.accesscode,dbu);
  }

}






