package gs.conf;
import java.io.*;
import java.io.IOException;

import java.util.Hashtable;
import java.util.Enumeration ;

import javax.servlet.http.HttpServletRequest;

import gs.cache.*;
import gs.admin.*;
import gs.db.JDBC;

public class Configuration {
  public static String configurationFile="/home/B10E/msen7/oserver/GrdSys/servlets/gs/conf/configuration.dat";
  public static boolean LOADED=false;
  Configuration(){}
  
  public static void setConfiguration(HttpServletRequest req)     
       throws Exception, IOException 
  {
    configurationFile=req.getParameter("CONFILE");

    gSystem.host=req.getParameter("HOST");
    gSystem.home=req.getParameter("HOME");
    gSystem.images=req.getParameter("IMAGES");
    gSystem.htdocs=req.getParameter("HTDOCS");
    gSystem.cgi=req.getParameter("CGI");
    gSystem.servlet=req.getParameter("SERVLET");
    gSystem.bgcolor=req.getParameter("BGCOLOR");
    gSystem.background=req.getParameter("BACKGROUND");
    gSystem.style=req.getParameter("STYLE");
 
    JDBC.driver=req.getParameter("DRIVER");
    JDBC.url=req.getParameter("URL");

    StudentCache.size=Integer.parseInt(req.getParameter("SCACHE"));
    AssignmentCache.size=Integer.parseInt(req.getParameter("ACACHE"));
    CourseCache.size=Integer.parseInt(req.getParameter("CCACHE"));
    UserCache.size=Integer.parseInt(req.getParameter("UCACHE"));

    StudentCache.EXPIRE=Integer.parseInt(req.getParameter("EXPIRE"));
    saveConfiguration();
  }
  public static void readConfiguration(Hashtable ht) throws Exception, IOException 
  {
    ht.put("CONFILE",configurationFile);
    ht.put("HOST",gSystem.host);
    ht.put("HOME",gSystem.home);
    ht.put("IMAGES",gSystem.images);
    ht.put("HTDOCS",gSystem.htdocs);
    ht.put("CGI",gSystem.cgi);
    ht.put("SERVLET",gSystem.servlet);
    ht.put("DRIVER",JDBC.driver);
    ht.put("URL",JDBC.url);
 
    ht.put("SCACHE",Integer.toString(StudentCache.size));
    ht.put("ACACHE",Integer.toString(AssignmentCache.size));
    ht.put("CCACHE",Integer.toString(CourseCache.size));
    ht.put("UCACHE",Integer.toString(UserCache.size));

    ht.put("BGCOLOR",gSystem.bgcolor);
    ht.put("BACKGROUND",gSystem.background);
    ht.put("STYLE",gSystem.style);

    ht.put("EXPIRE",Integer.toString(StudentCache.EXPIRE));
  }
  public static void saveConfiguration() throws Exception, IOException 
  {
    PrintWriter conf=null;
    try {
      conf= new PrintWriter
	(new DataOutputStream
	 (new FileOutputStream
	  ( configurationFile)));
      
    } catch (IOException e) {
      System.out.println("File not opened properly\n"+e.toString());
      //System.exit(1);
    }
    Hashtable ht=new Hashtable();
    readConfiguration(ht);
    Enumeration keys=ht.keys();Enumeration elements=ht.elements();
    while (   keys.hasMoreElements() ) {
      conf.println(keys.nextElement());
      conf.println(elements.nextElement());
    }
    conf.close();
   
  }
  public static void loadConfiguration()
  {
    if (LOADED) return;
    LOADED=true;

    try {
      Hashtable ht=new Hashtable();
      File htmlfile = new File( configurationFile );

      if(!htmlfile.isFile()) 
	System.out.println("Could not open the file "+configurationFile+"!");
      else {
	
	BufferedReader lines = 
	  new BufferedReader
	  (new InputStreamReader
	   (new FileInputStream( htmlfile )));
	
	String key, value="";
	while ( ( key = lines.readLine() ) != null ) {
	  value=lines.readLine();
	  if (value!=null)
	    ht.put(key,value);
	}
      }
    configurationFile=(String)ht.get("CONFILE");

    gSystem.host=(String)ht.get("HOST");
    gSystem.home=(String)ht.get("HOME");
    gSystem.images=(String)ht.get("IMAGES");
    gSystem.htdocs=(String)ht.get("HTDOCS");
    gSystem.cgi=(String)ht.get("CGI");
    gSystem.servlet=(String)ht.get("SERVLET");
    gSystem.bgcolor=(String)ht.get("BGCOLOR");
    gSystem.background=(String)ht.get("BACKGROUND");
    gSystem.style=(String)ht.get("STYLE");
 
    JDBC.driver=(String)ht.get("DRIVER");
    JDBC.url=(String)ht.get("URL");

    StudentCache.size=Integer.parseInt((String)ht.get("SCACHE"));
    AssignmentCache.size=Integer.parseInt((String)ht.get("ACACHE"));
    CourseCache.size=Integer.parseInt((String)ht.get("CCACHE"));
    UserCache.size=Integer.parseInt((String)ht.get("UCACHE"));

    StudentCache.EXPIRE=Integer.parseInt((String)ht.get("EXPIRE"));




    }catch (IOException e) {}
  }
}
